/**
 * AD2.java
 *
 * File generated from the medication2::AD2 uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication2;

import java.util.ArrayList;
import java.util.List;

// End of user code
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlElementRefs;
import javax.xml.bind.annotation.XmlMixed;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class AD2.
 *
 * 
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "AD", propOrder = {
	"mixed",
	"isNotOrdered",
	"use"
})
@XmlRootElement(name = "AD2")
public class AD2 extends net.ihe.gazelle.medication2.ANY2 implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElementRefs({
			@XmlElementRef(name = "delimiter", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "country", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "state", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "county", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "city", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "postalCode", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "streetAddressLine", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "houseNumber", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "houseNumberNumeric", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "direction", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "streetName", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "streetNameBase", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "streetNameType", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "additionalLocator", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "unitID", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "unitType", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "careOf", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "censusTract", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "deliveryAddressLine", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "deliveryInstallationType", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "deliveryInstallationArea", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "deliveryInstallationQualifier", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "deliveryMode", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "deliveryModeIdentifier", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "buildingNumberSuffix", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "postBox", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "precinct", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "useablePeriod", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class)
		})
		@XmlMixed
	public List<java.io.Serializable> mixed;
	/**
	 *                       A boolean value specifying whether
	                            the order of the                      address parts is known or not.
	                            While the address parts                      are always a Sequence, the
	                            order in which they are                      presented may or may not be
	                            known. Where this matters, the                      isNotOrdered
	                            property can be used to convey this                      information.
	                        .
	 */
	@XmlAttribute(name = "isNotOrdered")
	public java.lang.Boolean isNotOrdered;
	/**
	 *                       A set of codes advising a system or
	                            user which address                      in a set of like addresses to
	                            select for a given purpose.                   .
	 */
	@XmlAttribute(name = "use")
	public java.lang.String use;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return mixed.
	 * @return mixed
	 */
	public List<java.io.Serializable> getMixed() {
		if (mixed == null) {
	        mixed = new ArrayList<java.io.Serializable>();
	    }
	    return mixed;
	}
	
	/**
	 * Set a value to attribute mixed.
	 * @param mixed.
	 */
	public void setMixed(List<java.io.Serializable> mixed) {
	    this.mixed = mixed;
	}
	
	
	
	/**
	 * Add a mixed to the mixed collection.
	 * @param mixed_elt Element to add.
	 */
	public void addMixed(java.io.Serializable mixed_elt) {
	    this.getMixed().add(mixed_elt);
	}
	
	/**
	 * Remove a mixed to the mixed collection.
	 * @param mixed_elt Element to remove
	 */
	public void removeMixed(java.io.Serializable mixed_elt) {
	    this.getMixed().remove(mixed_elt);
	}
	
	
	/**
	 * Return delimiter.
	 * @return delimiter
	 */
	public List<net.ihe.gazelle.medication2.AdxpDelimiter2> getDelimiter() {
		List<net.ihe.gazelle.medication2.AdxpDelimiter2> delimiter_el = new ArrayList<net.ihe.gazelle.medication2.AdxpDelimiter2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("delimiter")){
					delimiter_el.add( (net.ihe.gazelle.medication2.AdxpDelimiter2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return delimiter_el;
	}
	
	public void addDelimiter(net.ihe.gazelle.medication2.AdxpDelimiter2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpDelimiter2> jobj = of.createAD2Delimiter(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return country.
	 * @return country
	 */
	public List<net.ihe.gazelle.medication2.AdxpCountry2> getCountry() {
		List<net.ihe.gazelle.medication2.AdxpCountry2> country_el = new ArrayList<net.ihe.gazelle.medication2.AdxpCountry2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("country")){
					country_el.add( (net.ihe.gazelle.medication2.AdxpCountry2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return country_el;
	}
	
	public void addCountry(net.ihe.gazelle.medication2.AdxpCountry2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpCountry2> jobj = of.createAD2Country(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return state.
	 * @return state
	 */
	public List<net.ihe.gazelle.medication2.AdxpState2> getState() {
		List<net.ihe.gazelle.medication2.AdxpState2> state_el = new ArrayList<net.ihe.gazelle.medication2.AdxpState2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("state")){
					state_el.add( (net.ihe.gazelle.medication2.AdxpState2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return state_el;
	}
	
	public void addState(net.ihe.gazelle.medication2.AdxpState2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpState2> jobj = of.createAD2State(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return county.
	 * @return county
	 */
	public List<net.ihe.gazelle.medication2.AdxpCounty2> getCounty() {
		List<net.ihe.gazelle.medication2.AdxpCounty2> county_el = new ArrayList<net.ihe.gazelle.medication2.AdxpCounty2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("county")){
					county_el.add( (net.ihe.gazelle.medication2.AdxpCounty2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return county_el;
	}
	
	public void addCounty(net.ihe.gazelle.medication2.AdxpCounty2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpCounty2> jobj = of.createAD2County(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return city.
	 * @return city
	 */
	public List<net.ihe.gazelle.medication2.AdxpCity2> getCity() {
		List<net.ihe.gazelle.medication2.AdxpCity2> city_el = new ArrayList<net.ihe.gazelle.medication2.AdxpCity2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("city")){
					city_el.add( (net.ihe.gazelle.medication2.AdxpCity2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return city_el;
	}
	
	public void addCity(net.ihe.gazelle.medication2.AdxpCity2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpCity2> jobj = of.createAD2City(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return postalCode.
	 * @return postalCode
	 */
	public List<net.ihe.gazelle.medication2.AdxpPostalCode2> getPostalCode() {
		List<net.ihe.gazelle.medication2.AdxpPostalCode2> postalCode_el = new ArrayList<net.ihe.gazelle.medication2.AdxpPostalCode2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("postalCode")){
					postalCode_el.add( (net.ihe.gazelle.medication2.AdxpPostalCode2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return postalCode_el;
	}
	
	public void addPostalCode(net.ihe.gazelle.medication2.AdxpPostalCode2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpPostalCode2> jobj = of.createAD2PostalCode(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return streetAddressLine.
	 * @return streetAddressLine
	 */
	public List<net.ihe.gazelle.medication2.AdxpStreetAddressLine2> getStreetAddressLine() {
		List<net.ihe.gazelle.medication2.AdxpStreetAddressLine2> streetAddressLine_el = new ArrayList<net.ihe.gazelle.medication2.AdxpStreetAddressLine2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("streetAddressLine")){
					streetAddressLine_el.add( (net.ihe.gazelle.medication2.AdxpStreetAddressLine2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return streetAddressLine_el;
	}
	
	public void addStreetAddressLine(net.ihe.gazelle.medication2.AdxpStreetAddressLine2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpStreetAddressLine2> jobj = of.createAD2StreetAddressLine(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return houseNumber.
	 * @return houseNumber
	 */
	public List<net.ihe.gazelle.medication2.AdxpHouseNumber2> getHouseNumber() {
		List<net.ihe.gazelle.medication2.AdxpHouseNumber2> houseNumber_el = new ArrayList<net.ihe.gazelle.medication2.AdxpHouseNumber2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("houseNumber")){
					houseNumber_el.add( (net.ihe.gazelle.medication2.AdxpHouseNumber2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return houseNumber_el;
	}
	
	public void addHouseNumber(net.ihe.gazelle.medication2.AdxpHouseNumber2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpHouseNumber2> jobj = of.createAD2HouseNumber(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return houseNumberNumeric.
	 * @return houseNumberNumeric
	 */
	public List<net.ihe.gazelle.medication2.AdxpHouseNumberNumeric2> getHouseNumberNumeric() {
		List<net.ihe.gazelle.medication2.AdxpHouseNumberNumeric2> houseNumberNumeric_el = new ArrayList<net.ihe.gazelle.medication2.AdxpHouseNumberNumeric2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("houseNumberNumeric")){
					houseNumberNumeric_el.add( (net.ihe.gazelle.medication2.AdxpHouseNumberNumeric2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return houseNumberNumeric_el;
	}
	
	public void addHouseNumberNumeric(net.ihe.gazelle.medication2.AdxpHouseNumberNumeric2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpHouseNumberNumeric2> jobj = of.createAD2HouseNumberNumeric(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return direction.
	 * @return direction
	 */
	public List<net.ihe.gazelle.medication2.AdxpDirection2> getDirection() {
		List<net.ihe.gazelle.medication2.AdxpDirection2> direction_el = new ArrayList<net.ihe.gazelle.medication2.AdxpDirection2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("direction")){
					direction_el.add( (net.ihe.gazelle.medication2.AdxpDirection2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return direction_el;
	}
	
	public void addDirection(net.ihe.gazelle.medication2.AdxpDirection2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpDirection2> jobj = of.createAD2Direction(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return streetName.
	 * @return streetName
	 */
	public List<net.ihe.gazelle.medication2.AdxpStreetName2> getStreetName() {
		List<net.ihe.gazelle.medication2.AdxpStreetName2> streetName_el = new ArrayList<net.ihe.gazelle.medication2.AdxpStreetName2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("streetName")){
					streetName_el.add( (net.ihe.gazelle.medication2.AdxpStreetName2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return streetName_el;
	}
	
	public void addStreetName(net.ihe.gazelle.medication2.AdxpStreetName2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpStreetName2> jobj = of.createAD2StreetName(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return streetNameBase.
	 * @return streetNameBase
	 */
	public List<net.ihe.gazelle.medication2.AdxpStreetNameBase2> getStreetNameBase() {
		List<net.ihe.gazelle.medication2.AdxpStreetNameBase2> streetNameBase_el = new ArrayList<net.ihe.gazelle.medication2.AdxpStreetNameBase2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("streetNameBase")){
					streetNameBase_el.add( (net.ihe.gazelle.medication2.AdxpStreetNameBase2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return streetNameBase_el;
	}
	
	public void addStreetNameBase(net.ihe.gazelle.medication2.AdxpStreetNameBase2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpStreetNameBase2> jobj = of.createAD2StreetNameBase(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return streetNameType.
	 * @return streetNameType
	 */
	public List<net.ihe.gazelle.medication2.AdxpStreetNameType2> getStreetNameType() {
		List<net.ihe.gazelle.medication2.AdxpStreetNameType2> streetNameType_el = new ArrayList<net.ihe.gazelle.medication2.AdxpStreetNameType2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("streetNameType")){
					streetNameType_el.add( (net.ihe.gazelle.medication2.AdxpStreetNameType2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return streetNameType_el;
	}
	
	public void addStreetNameType(net.ihe.gazelle.medication2.AdxpStreetNameType2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpStreetNameType2> jobj = of.createAD2StreetNameType(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return additionalLocator.
	 * @return additionalLocator
	 */
	public List<net.ihe.gazelle.medication2.AdxpAdditionalLocator2> getAdditionalLocator() {
		List<net.ihe.gazelle.medication2.AdxpAdditionalLocator2> additionalLocator_el = new ArrayList<net.ihe.gazelle.medication2.AdxpAdditionalLocator2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("additionalLocator")){
					additionalLocator_el.add( (net.ihe.gazelle.medication2.AdxpAdditionalLocator2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return additionalLocator_el;
	}
	
	public void addAdditionalLocator(net.ihe.gazelle.medication2.AdxpAdditionalLocator2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpAdditionalLocator2> jobj = of.createAD2AdditionalLocator(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return unitID.
	 * @return unitID
	 */
	public List<net.ihe.gazelle.medication2.AdxpUnitID2> getUnitID() {
		List<net.ihe.gazelle.medication2.AdxpUnitID2> unitID_el = new ArrayList<net.ihe.gazelle.medication2.AdxpUnitID2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("unitID")){
					unitID_el.add( (net.ihe.gazelle.medication2.AdxpUnitID2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return unitID_el;
	}
	
	public void addUnitID(net.ihe.gazelle.medication2.AdxpUnitID2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpUnitID2> jobj = of.createAD2UnitID(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return unitType.
	 * @return unitType
	 */
	public List<net.ihe.gazelle.medication2.AdxpUnitType2> getUnitType() {
		List<net.ihe.gazelle.medication2.AdxpUnitType2> unitType_el = new ArrayList<net.ihe.gazelle.medication2.AdxpUnitType2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("unitType")){
					unitType_el.add( (net.ihe.gazelle.medication2.AdxpUnitType2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return unitType_el;
	}
	
	public void addUnitType(net.ihe.gazelle.medication2.AdxpUnitType2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpUnitType2> jobj = of.createAD2UnitType(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return careOf.
	 * @return careOf
	 */
	public List<net.ihe.gazelle.medication2.AdxpCareOf2> getCareOf() {
		List<net.ihe.gazelle.medication2.AdxpCareOf2> careOf_el = new ArrayList<net.ihe.gazelle.medication2.AdxpCareOf2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("careOf")){
					careOf_el.add( (net.ihe.gazelle.medication2.AdxpCareOf2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return careOf_el;
	}
	
	public void addCareOf(net.ihe.gazelle.medication2.AdxpCareOf2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpCareOf2> jobj = of.createAD2CareOf(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return censusTract.
	 * @return censusTract
	 */
	public List<net.ihe.gazelle.medication2.AdxpCensusTract2> getCensusTract() {
		List<net.ihe.gazelle.medication2.AdxpCensusTract2> censusTract_el = new ArrayList<net.ihe.gazelle.medication2.AdxpCensusTract2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("censusTract")){
					censusTract_el.add( (net.ihe.gazelle.medication2.AdxpCensusTract2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return censusTract_el;
	}
	
	public void addCensusTract(net.ihe.gazelle.medication2.AdxpCensusTract2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpCensusTract2> jobj = of.createAD2CensusTract(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return deliveryAddressLine.
	 * @return deliveryAddressLine
	 */
	public List<net.ihe.gazelle.medication2.AdxpDeliveryAddressLine2> getDeliveryAddressLine() {
		List<net.ihe.gazelle.medication2.AdxpDeliveryAddressLine2> deliveryAddressLine_el = new ArrayList<net.ihe.gazelle.medication2.AdxpDeliveryAddressLine2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("deliveryAddressLine")){
					deliveryAddressLine_el.add( (net.ihe.gazelle.medication2.AdxpDeliveryAddressLine2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return deliveryAddressLine_el;
	}
	
	public void addDeliveryAddressLine(net.ihe.gazelle.medication2.AdxpDeliveryAddressLine2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpDeliveryAddressLine2> jobj = of.createAD2DeliveryAddressLine(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return deliveryInstallationType.
	 * @return deliveryInstallationType
	 */
	public List<net.ihe.gazelle.medication2.AdxpDeliveryInstallationType2> getDeliveryInstallationType() {
		List<net.ihe.gazelle.medication2.AdxpDeliveryInstallationType2> deliveryInstallationType_el = new ArrayList<net.ihe.gazelle.medication2.AdxpDeliveryInstallationType2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("deliveryInstallationType")){
					deliveryInstallationType_el.add( (net.ihe.gazelle.medication2.AdxpDeliveryInstallationType2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return deliveryInstallationType_el;
	}
	
	public void addDeliveryInstallationType(net.ihe.gazelle.medication2.AdxpDeliveryInstallationType2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpDeliveryInstallationType2> jobj = of.createAD2DeliveryInstallationType(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return deliveryInstallationArea.
	 * @return deliveryInstallationArea
	 */
	public List<net.ihe.gazelle.medication2.AdxpDeliveryInstallationArea2> getDeliveryInstallationArea() {
		List<net.ihe.gazelle.medication2.AdxpDeliveryInstallationArea2> deliveryInstallationArea_el = new ArrayList<net.ihe.gazelle.medication2.AdxpDeliveryInstallationArea2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("deliveryInstallationArea")){
					deliveryInstallationArea_el.add( (net.ihe.gazelle.medication2.AdxpDeliveryInstallationArea2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return deliveryInstallationArea_el;
	}
	
	public void addDeliveryInstallationArea(net.ihe.gazelle.medication2.AdxpDeliveryInstallationArea2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpDeliveryInstallationArea2> jobj = of.createAD2DeliveryInstallationArea(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return deliveryInstallationQualifier.
	 * @return deliveryInstallationQualifier
	 */
	public List<net.ihe.gazelle.medication2.AdxpDeliveryInstallationQualifier2> getDeliveryInstallationQualifier() {
		List<net.ihe.gazelle.medication2.AdxpDeliveryInstallationQualifier2> deliveryInstallationQualifier_el = new ArrayList<net.ihe.gazelle.medication2.AdxpDeliveryInstallationQualifier2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("deliveryInstallationQualifier")){
					deliveryInstallationQualifier_el.add( (net.ihe.gazelle.medication2.AdxpDeliveryInstallationQualifier2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return deliveryInstallationQualifier_el;
	}
	
	public void addDeliveryInstallationQualifier(net.ihe.gazelle.medication2.AdxpDeliveryInstallationQualifier2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpDeliveryInstallationQualifier2> jobj = of.createAD2DeliveryInstallationQualifier(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return deliveryMode.
	 * @return deliveryMode
	 */
	public List<net.ihe.gazelle.medication2.AdxpDeliveryMode2> getDeliveryMode() {
		List<net.ihe.gazelle.medication2.AdxpDeliveryMode2> deliveryMode_el = new ArrayList<net.ihe.gazelle.medication2.AdxpDeliveryMode2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("deliveryMode")){
					deliveryMode_el.add( (net.ihe.gazelle.medication2.AdxpDeliveryMode2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return deliveryMode_el;
	}
	
	public void addDeliveryMode(net.ihe.gazelle.medication2.AdxpDeliveryMode2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpDeliveryMode2> jobj = of.createAD2DeliveryMode(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return deliveryModeIdentifier.
	 * @return deliveryModeIdentifier
	 */
	public List<net.ihe.gazelle.medication2.AdxpDeliveryModeIdentifier2> getDeliveryModeIdentifier() {
		List<net.ihe.gazelle.medication2.AdxpDeliveryModeIdentifier2> deliveryModeIdentifier_el = new ArrayList<net.ihe.gazelle.medication2.AdxpDeliveryModeIdentifier2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("deliveryModeIdentifier")){
					deliveryModeIdentifier_el.add( (net.ihe.gazelle.medication2.AdxpDeliveryModeIdentifier2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return deliveryModeIdentifier_el;
	}
	
	public void addDeliveryModeIdentifier(net.ihe.gazelle.medication2.AdxpDeliveryModeIdentifier2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpDeliveryModeIdentifier2> jobj = of.createAD2DeliveryModeIdentifier(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return buildingNumberSuffix.
	 * @return buildingNumberSuffix
	 */
	public List<net.ihe.gazelle.medication2.AdxpBuildingNumberSuffix2> getBuildingNumberSuffix() {
		List<net.ihe.gazelle.medication2.AdxpBuildingNumberSuffix2> buildingNumberSuffix_el = new ArrayList<net.ihe.gazelle.medication2.AdxpBuildingNumberSuffix2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("buildingNumberSuffix")){
					buildingNumberSuffix_el.add( (net.ihe.gazelle.medication2.AdxpBuildingNumberSuffix2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return buildingNumberSuffix_el;
	}
	
	public void addBuildingNumberSuffix(net.ihe.gazelle.medication2.AdxpBuildingNumberSuffix2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpBuildingNumberSuffix2> jobj = of.createAD2BuildingNumberSuffix(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return postBox.
	 * @return postBox
	 */
	public List<net.ihe.gazelle.medication2.AdxpPostBox2> getPostBox() {
		List<net.ihe.gazelle.medication2.AdxpPostBox2> postBox_el = new ArrayList<net.ihe.gazelle.medication2.AdxpPostBox2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("postBox")){
					postBox_el.add( (net.ihe.gazelle.medication2.AdxpPostBox2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return postBox_el;
	}
	
	public void addPostBox(net.ihe.gazelle.medication2.AdxpPostBox2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpPostBox2> jobj = of.createAD2PostBox(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return precinct.
	 * @return precinct
	 */
	public List<net.ihe.gazelle.medication2.AdxpPrecinct2> getPrecinct() {
		List<net.ihe.gazelle.medication2.AdxpPrecinct2> precinct_el = new ArrayList<net.ihe.gazelle.medication2.AdxpPrecinct2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("precinct")){
					precinct_el.add( (net.ihe.gazelle.medication2.AdxpPrecinct2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return precinct_el;
	}
	
	public void addPrecinct(net.ihe.gazelle.medication2.AdxpPrecinct2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.AdxpPrecinct2> jobj = of.createAD2Precinct(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return useablePeriod.
	 * @return useablePeriod
	 */
	public List<net.ihe.gazelle.medication2.SXCMTS2> getUseablePeriod() {
		List<net.ihe.gazelle.medication2.SXCMTS2> useablePeriod_el = new ArrayList<net.ihe.gazelle.medication2.SXCMTS2>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("useablePeriod")){
					useablePeriod_el.add( (net.ihe.gazelle.medication2.SXCMTS2) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return useablePeriod_el;
	}
	
	public void addUseablePeriod(net.ihe.gazelle.medication2.SXCMTS2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication2.SXCMTS2> jobj = of.createAD2UseablePeriod(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return isNotOrdered.
	 * @return isNotOrdered :                       A boolean value specifying whether
	                            the order of the                      address parts is known or not.
	                            While the address parts                      are always a Sequence, the
	                            order in which they are                      presented may or may not be
	                            known. Where this matters, the                      isNotOrdered
	                            property can be used to convey this                      information.
	                        
	 */
	public java.lang.Boolean getIsNotOrdered() {
	    return isNotOrdered;
	}
	
	/**
	 * Set a value to attribute isNotOrdered.
	 * @param isNotOrdered :                       A boolean value specifying whether
	                            the order of the                      address parts is known or not.
	                            While the address parts                      are always a Sequence, the
	                            order in which they are                      presented may or may not be
	                            known. Where this matters, the                      isNotOrdered
	                            property can be used to convey this                      information.
	                        .
	 */
	public void setIsNotOrdered(java.lang.Boolean isNotOrdered) {
	    this.isNotOrdered = isNotOrdered;
	}
	
	
	
	
	/**
	 * Return use.
	 * @return use :                       A set of codes advising a system or
	                            user which address                      in a set of like addresses to
	                            select for a given purpose.                   
	 */
	public java.lang.String getUse() {
	    return use;
	}
	
	/**
	 * Set a value to attribute use.
	 * @param use :                       A set of codes advising a system or
	                            user which address                      in a set of like addresses to
	                            select for a given purpose.                   .
	 */
	public void setUse(java.lang.String use) {
	    this.use = use;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication2");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "AD2").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	public List<String> getListStringValues(){
		List<String> res = new ArrayList<String>();
		for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof String){
				res.add((String)obj);
			}
		} 
		return res;
	}
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(AD2 aD2, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (aD2 != null){
   			net.ihe.gazelle.medication2.ANY2.validateByModule(aD2, _location, cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpDelimiter2 delimiter: aD2.getDelimiter()){
					net.ihe.gazelle.medication2.AdxpDelimiter2.validateByModule(delimiter, _location + "/delimiter[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpCountry2 country: aD2.getCountry()){
					net.ihe.gazelle.medication2.AdxpCountry2.validateByModule(country, _location + "/country[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpState2 state: aD2.getState()){
					net.ihe.gazelle.medication2.AdxpState2.validateByModule(state, _location + "/state[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpCounty2 county: aD2.getCounty()){
					net.ihe.gazelle.medication2.AdxpCounty2.validateByModule(county, _location + "/county[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpCity2 city: aD2.getCity()){
					net.ihe.gazelle.medication2.AdxpCity2.validateByModule(city, _location + "/city[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpPostalCode2 postalCode: aD2.getPostalCode()){
					net.ihe.gazelle.medication2.AdxpPostalCode2.validateByModule(postalCode, _location + "/postalCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpStreetAddressLine2 streetAddressLine: aD2.getStreetAddressLine()){
					net.ihe.gazelle.medication2.AdxpStreetAddressLine2.validateByModule(streetAddressLine, _location + "/streetAddressLine[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpHouseNumber2 houseNumber: aD2.getHouseNumber()){
					net.ihe.gazelle.medication2.AdxpHouseNumber2.validateByModule(houseNumber, _location + "/houseNumber[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpHouseNumberNumeric2 houseNumberNumeric: aD2.getHouseNumberNumeric()){
					net.ihe.gazelle.medication2.AdxpHouseNumberNumeric2.validateByModule(houseNumberNumeric, _location + "/houseNumberNumeric[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpDirection2 direction: aD2.getDirection()){
					net.ihe.gazelle.medication2.AdxpDirection2.validateByModule(direction, _location + "/direction[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpStreetName2 streetName: aD2.getStreetName()){
					net.ihe.gazelle.medication2.AdxpStreetName2.validateByModule(streetName, _location + "/streetName[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpStreetNameBase2 streetNameBase: aD2.getStreetNameBase()){
					net.ihe.gazelle.medication2.AdxpStreetNameBase2.validateByModule(streetNameBase, _location + "/streetNameBase[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpStreetNameType2 streetNameType: aD2.getStreetNameType()){
					net.ihe.gazelle.medication2.AdxpStreetNameType2.validateByModule(streetNameType, _location + "/streetNameType[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpAdditionalLocator2 additionalLocator: aD2.getAdditionalLocator()){
					net.ihe.gazelle.medication2.AdxpAdditionalLocator2.validateByModule(additionalLocator, _location + "/additionalLocator[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpUnitID2 unitID: aD2.getUnitID()){
					net.ihe.gazelle.medication2.AdxpUnitID2.validateByModule(unitID, _location + "/unitID[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpUnitType2 unitType: aD2.getUnitType()){
					net.ihe.gazelle.medication2.AdxpUnitType2.validateByModule(unitType, _location + "/unitType[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpCareOf2 careOf: aD2.getCareOf()){
					net.ihe.gazelle.medication2.AdxpCareOf2.validateByModule(careOf, _location + "/careOf[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpCensusTract2 censusTract: aD2.getCensusTract()){
					net.ihe.gazelle.medication2.AdxpCensusTract2.validateByModule(censusTract, _location + "/censusTract[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpDeliveryAddressLine2 deliveryAddressLine: aD2.getDeliveryAddressLine()){
					net.ihe.gazelle.medication2.AdxpDeliveryAddressLine2.validateByModule(deliveryAddressLine, _location + "/deliveryAddressLine[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpDeliveryInstallationType2 deliveryInstallationType: aD2.getDeliveryInstallationType()){
					net.ihe.gazelle.medication2.AdxpDeliveryInstallationType2.validateByModule(deliveryInstallationType, _location + "/deliveryInstallationType[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpDeliveryInstallationArea2 deliveryInstallationArea: aD2.getDeliveryInstallationArea()){
					net.ihe.gazelle.medication2.AdxpDeliveryInstallationArea2.validateByModule(deliveryInstallationArea, _location + "/deliveryInstallationArea[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpDeliveryInstallationQualifier2 deliveryInstallationQualifier: aD2.getDeliveryInstallationQualifier()){
					net.ihe.gazelle.medication2.AdxpDeliveryInstallationQualifier2.validateByModule(deliveryInstallationQualifier, _location + "/deliveryInstallationQualifier[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpDeliveryMode2 deliveryMode: aD2.getDeliveryMode()){
					net.ihe.gazelle.medication2.AdxpDeliveryMode2.validateByModule(deliveryMode, _location + "/deliveryMode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpDeliveryModeIdentifier2 deliveryModeIdentifier: aD2.getDeliveryModeIdentifier()){
					net.ihe.gazelle.medication2.AdxpDeliveryModeIdentifier2.validateByModule(deliveryModeIdentifier, _location + "/deliveryModeIdentifier[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpBuildingNumberSuffix2 buildingNumberSuffix: aD2.getBuildingNumberSuffix()){
					net.ihe.gazelle.medication2.AdxpBuildingNumberSuffix2.validateByModule(buildingNumberSuffix, _location + "/buildingNumberSuffix[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpPostBox2 postBox: aD2.getPostBox()){
					net.ihe.gazelle.medication2.AdxpPostBox2.validateByModule(postBox, _location + "/postBox[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.AdxpPrecinct2 precinct: aD2.getPrecinct()){
					net.ihe.gazelle.medication2.AdxpPrecinct2.validateByModule(precinct, _location + "/precinct[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.SXCMTS2 useablePeriod: aD2.getUseablePeriod()){
					net.ihe.gazelle.medication2.SXCMTS2.validateByModule(useablePeriod, _location + "/useablePeriod[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
    	}
    }

}
